Index: nbtab.h
===================================================================
--- nbtab.h	(revision 201)
+++ nbtab.h	(revision 177)
@@ -20,13 +20,12 @@
 #define NBTAB_H
 
-class MapStorage;
-class EpsWin;
-class MapWin;
-class DesignWin;
-class GraphDisplayerCanvas;
-
+class NoteBookTab;
+
+#include "mapstorage.h"
+#include "map_win.h"
+#include "design_win.h"
+#include "graph_displayer_canvas.h"
 #include <libgnomecanvasmm.h>
 #include <libgnomecanvasmm/polygon.h>
-#include "map_value.h"
 
 ///One tab in the Notebook that is placed in the main window (\ref MainWin).
@@ -59,5 +58,5 @@
   
   ///Maps assigned to the graph displayed in this \ref NoteBookTab of notebook.
-  MapStorage * mapstorage;
+  MapStorage mapstorage;
     
   ///Title changement indicator.
@@ -99,7 +98,4 @@
   bool designwinexists;
 
-  ///Indicates whether the \ref EpsWin is opened or not. See \ref epswin.
-  bool epswinexists;
-
   ///Address of the only \ref MapWin that the \ref NoteBookTab can open.
 
@@ -117,11 +113,4 @@
   ///more complicated to synchronize them.
   DesignWin * designwin;
-
-  ///Address of the only \ref EpsWin that the \ref NoteBookTab can open.
-
-  ///Only one of this window can be opened at the same time (\ref epswinexists), 
-  ///because there is no need for more, one per tab is enough.
-  ///There won't be benefit of more than one.
-  EpsWin * epswin;
 
 public:
@@ -174,5 +163,5 @@
   ///This call-forwarder function is needed, because \ref Mapstorage does not know \ref MapWin
   ///\param mapname name of new map
-  void registerNewEdgeMap(std::string mapname, MapValue::Type type);
+  void registerNewEdgeMap(std::string mapname);
 
   ///Registers recently created nodemap in \ref MapWin.
@@ -183,5 +172,5 @@
   ///This call-forwarder function is needed, because \ref Mapstorage does not know \ref MapWin
   ///\param mapname name of new map
-  void registerNewNodeMap(std::string mapname, MapValue::Type type);
+  void registerNewNodeMap(std::string mapname);
 
   ///Pops up and registrates the \ref MapWin of \ref NoteBookTab.
@@ -197,9 +186,4 @@
   void createDesignWin(std::string);
 
-  ///Pops up a window, that can dump graph to EPS
-
-  ///Different parameters can be set here.
-  void createExportToEPSWin(std::string);
-
   ///Closes and deregistrates the \ref MapWin of \ref NoteBookTab.
   
@@ -208,15 +192,5 @@
   void closeMapWin();
 
-  ///Closes and deregistrates the \ref DesignWin of \ref NoteBookTab.
-  
-  ///See also
-  ///\ref designwin.
   bool closeDesignWin(GdkEventAny *);
-
-  ///Closes and deregistrates the \ref EpsWin of \ref NoteBookTab.
-  
-  ///See also
-  ///\ref epswin.
-  void closeEpsWin();
 
   ///Sets node representation settings
@@ -229,14 +203,8 @@
   void reDesignGraph();
 
-  ///Lets Mapstorage export the graph to EPS
-  void exportGraphToEPS(std::vector<bool>, std::string, std::string);
-
   ///\ref MapWin calls this function when it updates the maplist in comboboxes.
   void active_maps_needed();
 
 private:
-  ///Called when title of tab has changed
-  void title_changed(std::string);
-
   ///Signal connection from \ref MapStorage to \ref MapWin
 
Index: new_map_win.cc
===================================================================
--- new_map_win.cc	(revision 201)
+++ new_map_win.cc	(revision 174)
@@ -18,6 +18,4 @@
 
 #include <new_map_win.h>
-#include <nbtab.h>
-#include <mapstorage.h>
 
 bool NewMapWin::closeIfEscapeIsPressed(GdkEventKey* e)
@@ -30,5 +28,5 @@
 }
 
-NewMapWin::NewMapWin(const std::string& title, NoteBookTab & mw, bool itisedge, bool edgenode, MapType type):Gtk::Dialog(title, true, true),mytab(mw),node("Create NodeMap"),edge("Create EdgeMap"),map_type(type)
+NewMapWin::NewMapWin(const std::string& title, NoteBookTab & mw, bool itisedge, bool edgenode):Gtk::Dialog(title, true, true),mytab(mw),node("Create NodeMap"),edge("Create EdgeMap")
 {
   set_default_size(200, 50);
@@ -39,5 +37,5 @@
 
   //entries
-  table=new Gtk::Table(5, 2, false);
+  table=new Gtk::Table(3, 2, false);
 
   label=new Gtk::Label;
@@ -48,43 +46,31 @@
   (*table).attach(name,1,2,0,1,Gtk::SHRINK,Gtk::SHRINK,10,3);
 
-  lblType.set_label("Element type:");
-  if (map_type & NUM)
-    cbType.append_text("Numeric");
-  if (map_type & STR)
-    cbType.append_text("String");
-  cbType.set_active(0);
-
-  (*table).attach(lblType,0,1,1,2,Gtk::SHRINK,Gtk::SHRINK,10,3);
-  (*table).attach(cbType, 1,2,1,2,Gtk::SHRINK,Gtk::SHRINK,10,3);
-
   label=new Gtk::Label;
   label->set_text("Default value in the map:");
   default_value.set_text("0");
 
-  (*table).attach(*label,0,1,2,3,Gtk::SHRINK,Gtk::SHRINK,10,3);
-  (*table).attach(default_value,1,2,2,3,Gtk::SHRINK,Gtk::SHRINK,10,3);
+  (*table).attach(*label,0,1,1,2,Gtk::SHRINK,Gtk::SHRINK,10,3);
+  (*table).attach(default_value,1,2,1,2,Gtk::SHRINK,Gtk::SHRINK,10,3);
 
   //node vs. edge map selector
   Gtk::RadioButton::Group group = node.get_group();
   edge.set_group(group);
-
+  
   if(edgenode)
-  {
-    (*table).attach(node,0,1,3,4,Gtk::SHRINK,Gtk::SHRINK,10,3);
-    (*table).attach(edge,1,2,3,4,Gtk::SHRINK,Gtk::SHRINK,10,3);
-  }
+    {
+      (*table).attach(node,0,1,2,3,Gtk::SHRINK,Gtk::SHRINK,10,3);
+      (*table).attach(edge,1,2,2,3,Gtk::SHRINK,Gtk::SHRINK,10,3);
+    }
   else
-  {
-    if(itisedge)
-    {
-      edge.set_active();
-    }
-    else
-    {
-      node.set_active();
-    }
-  }
-
-  (*table).attach(lblErrorMsg,0,2,4,5,Gtk::SHRINK,Gtk::SHRINK,10,3);
+    {
+      if(itisedge)
+	{
+	  edge.set_active();
+	}
+      else
+	{
+	  node.set_active();
+	}
+    }
 
   vbox->pack_start(*table);
@@ -97,240 +83,212 @@
 }
 
-void NewMapWin::setErrorMsg(const Glib::ustring& msg)
-{
-  lblErrorMsg.set_markup("<i><small>" + msg + "</small></i>");
-}
-
-std::vector<double>* NewMapWin::evaluate_expr(const std::string polishform, bool itisedge)
-{
-  MapStorage& ms = *mytab.mapstorage;
-
-  std::vector<double>* ret = new std::vector<double>;
-  std::stack<double> polishstack;
-
-  if (itisedge)
-  {
-    for(EdgeIt k(ms.graph); k!=INVALID; ++k)
-    {
-      for(int i=0;i<(int)polishform.size();i++)
-      {
-        double op1=0, op2=0;
-        bool operation=true;
-        switch(polishform[i])
-        {
-          case '+':
-          case '-':
-          case '/':
-          case '*':
-            op1=polishstack.top();
-            polishstack.pop();
-            op2=polishstack.top();
-            polishstack.pop();
-            break;
-          default:
-            //substitute variable
-            std::vector<std::string> maps = ms.getEdgeMapList(NUM);
-            bool itisvar=(std::find(maps.begin(), maps.end(), ch2var[ polishform[i] ]) != maps.end());
-            if(itisvar)
-            {
-              polishstack.push(ms.get(ch2var[ polishform[i] ], k));
-            }
-            else
-            {
-              polishstack.push(atof(ch2var[ polishform[i] ].c_str()));
-            }
-            operation=false;
-            break;
-        }
-        if(operation)
-        {
-          double res;
-          switch(polishform[i])
-          {
-            case '+':
-              res=op1+op2;
-              break;
-            case '-':
-              res=op2-op1;
-              break;
-            case '/':
-              res=op2/op1;
-              break;
-            case '*':
-              res=op1*op2;
-              break;
-            default:
-              std::cout << "How could we get here?" << std::endl;
-              break;
-          }
-          polishstack.push(res);
-        }
-      }//foreach letter in polishform
-      ret->push_back(polishstack.top());
-    }//foreach edge
-  }
-  else
-  {
-    for(NodeIt k(ms.graph); k!=INVALID; ++k)
-    {
-      for(int i=0;i<(int)polishform.size();i++)
-      {
-        double op1=0, op2=0;
-        bool operation=true;
-        switch(polishform[i])
-        {
-          case '+':
-          case '-':
-          case '/':
-          case '*':
-            op1=polishstack.top();
-            polishstack.pop();
-            op2=polishstack.top();
-            polishstack.pop();
-            break;
-          default:
-            //substitute variable
-            std::vector<std::string> maps = ms.getNodeMapList(NUM);
-            bool itisvar=(std::find(maps.begin(), maps.end(), ch2var[ polishform[i] ]) != maps.end());
-            if(itisvar)
-            {
-              polishstack.push(ms.get(ch2var[ polishform[i] ], k));
-            }
-            else
-            {
-              polishstack.push(atof(ch2var[ polishform[i] ].c_str()));
-            }
-            operation=false;
-            break;
-        }
-        if(operation)
-        {
-          double res;
-          switch(polishform[i])
-          {
-            case '+':
-              res=op1+op2;
-              break;
-            case '-':
-              res=op2-op1;
-              break;
-            case '/':
-              res=op2/op1;
-              break;
-            case '*':
-              res=op1*op2;
-              break;
-            default:
-              std::cout << "How could we get here?" << std::endl;
-              break;
-          }
-          polishstack.push(res);
-        }
-      }//foreach letter in polishform
-      ret->push_back(polishstack.top());
-    }//foreach edge
-  }
-  return ret;
-}
-
 void NewMapWin::on_response(int response_id)
 {
-  MapStorage& ms = *mytab.mapstorage;
-
   if(response_id==Gtk::RESPONSE_OK)
-  {
-    std::string map_name = name.get_text();
-    std::string def_val = default_value.get_text();
-
-    if (map_name.empty())
-    {
-      setErrorMsg("No map name given.");
-      return;
-    }
-
-    // check whether the map already exists
-    if (edge.get_active())
-    {
-      if (ms.edgeMapExists(map_name))
-      {
-        setErrorMsg("Map '" + map_name + "' already exists.");
-        return;
-      }
-    }
-    else
-    {
-      if (ms.nodeMapExists(map_name))
-      {
-        setErrorMsg("Map '" + map_name + "' already exists.");
-        return;
-      }
-    }
-
-    Glib::ustring text = cbType.get_active_text();
-    if (text == "Numeric")
-    {
-      double d;
-      char *endptr;
-      d = strtod(def_val.c_str(), &endptr);
-      if (def_val.c_str() + def_val.length() == endptr)
-      {
-        // the full string was a number
-        if (edge.get_active())
-          ms.createEdgeMap(map_name, MapValue::NUMERIC,
-              MapValue(d));
-        else
-          ms.createNodeMap(map_name, MapValue::NUMERIC,
-              MapValue(d));
-      }
+    {
+      double def_val=0;
+
+      //get and formulate text
+      std::string def_val_str=default_value.get_text();
+
+      bool only_nums=true;
+      for(int i=0;i<(int)def_val_str.size() && only_nums;i++)
+	{
+	  if( def_val_str[i]<'0' || def_val_str[i]>'9' )
+	    {
+	      only_nums=false;
+	    }
+	}
+      std::string polishform;
+
+      if(only_nums)
+	{
+	  def_val=atof(def_val_str.c_str());
+	}
       else
-      {
-        // let't try to evaluate the string as an arithmetic expression
-        std::string polishform =
-          string2Polishform(def_val, edge.get_active());
-        if (polishform.empty())
-          return;
-        std::vector<double>* values =
-          evaluate_expr(polishform, edge.get_active());
-        if (edge.get_active())
-        {
-          ms.createEdgeMap(map_name, MapValue::NUMERIC,
-              MapValue(0.0));
-          std::vector<double>::const_iterator vit = values->begin();
-          for (EdgeIt it(ms.graph); it != INVALID; ++it)
-          {
-            ms.set(map_name, it, MapValue(*vit));
-            ++vit;
-          }
-        }
-        else
-        {
-          ms.createNodeMap(map_name, MapValue::NUMERIC,
-              MapValue(0.0));
-          std::vector<double>::const_iterator vit = values->begin();
-          for (NodeIt it(ms.graph); it != INVALID; ++it)
-          {
-            ms.set(map_name, it, MapValue(*vit));
-            ++vit;
-          }
-        }
-        delete values;
-      }
-    }
-    else if (text == "String")
-    {
-      if (edge.get_active())
-        ms.createEdgeMap(map_name, MapValue::STRING,
-            MapValue(def_val));
-      else
-        ms.createNodeMap(map_name, MapValue::STRING,
-            MapValue(def_val));
-    }
-
-    name.set_text("");
-    default_value.set_text("0");
-    edge.show();
-    node.show();
-    hide();
-  }
+	{
+	  polishform=string2Polishform(def_val_str,edge.get_active());
+	}
+
+      //get name of text
+      std::string mapname=name.get_text();
+      
+      if(!mapname.empty()&&(!polishform.empty()||only_nums))
+	{
+	  int abortion=0;
+	  if(edge.get_active())
+	    {
+	      //create the new map
+	      Graph::EdgeMap<double> * emptr=new Graph::EdgeMap<double> (mytab.mapstorage.graph, def_val);
+	      
+	      if(!only_nums)
+		{
+		  std::stack<double> polishstack;
+		  
+		  for(EdgeIt k(mytab.mapstorage.graph); k!=INVALID; ++k)
+		    {
+		      for(int i=0;i<(int)polishform.size();i++)
+			{
+			  double op1=0, op2=0;
+			  bool operation=true;
+			  switch(polishform[i])
+			    {
+			    case '+':
+			    case '-':
+			    case '/':
+			    case '*':
+			      op1=polishstack.top();
+			      polishstack.pop();
+			      op2=polishstack.top();
+			      polishstack.pop();
+			      break;
+			    default:
+			      //substitute variable
+			      std::map< std::string,Graph::EdgeMap<double> * > ems=mytab.mapstorage.edgemap_storage;
+			      bool itisvar=(ems.find(ch2var[ polishform[i] ])!=ems.end());
+			      if(itisvar)
+				{
+				  polishstack.push( (*(mytab.mapstorage.edgemap_storage[ ch2var[ polishform[i] ] ]))[k]);
+				}
+			      else
+				{
+				  polishstack.push(atof(ch2var[ polishform[i] ].c_str()));
+				}
+			      operation=false;
+			      break;
+			    }
+			  if(operation)
+			    {
+			      double res;
+			      switch(polishform[i])
+				{
+				case '+':
+				  res=op1+op2;
+				  break;
+				case '-':
+				  res=op2-op1;
+				  break;
+				case '/':
+				  res=op2/op1;
+				  break;
+				case '*':
+				  res=op1*op2;
+				  break;
+				default:
+				  std::cout << "How could we get here?" << std::endl;
+				  break;
+				}
+			      polishstack.push(res);
+			    }
+			}//foreach letter in polishform
+		      (*emptr)[k]=polishstack.top(); 
+		    }//foreach edge
+		}//!only_nums
+
+	      //if addition was not successful addEdgeMap returns one.
+	      //cause can be that there is already a map named like the new one
+	      if(mytab.mapstorage.addEdgeMap(mapname, emptr, def_val))
+		{
+		  abortion=1;
+		}
+
+	      //add it to the list of the displayable maps
+	      //furthermore it is done by signals
+	      //mytab.registerNewEdgeMap(mapname);
+
+	      //display it
+	      //gdc.changeEdgeText(mapname);
+	    }
+	  else //!edge.get_active()
+	    {
+	      //create the new map
+	      Graph::NodeMap<double> * emptr=new Graph::NodeMap<double> (mytab.mapstorage.graph, def_val);
+
+	      if(!only_nums)
+		{
+		  std::stack<double> polishstack;
+  
+		  for(NodeIt k(mytab.mapstorage.graph); k!=INVALID; ++k)
+		    {
+		      for(int i=0;i<(int)polishform.size();i++)
+			{
+			  double op1=0, op2=0;
+			  bool operation=true;
+			  switch(polishform[i])
+			    {
+			    case '+':
+			    case '-':
+			    case '/':
+			    case '*':
+			      op1=polishstack.top();
+			      polishstack.pop();
+			      op2=polishstack.top();
+			      polishstack.pop();
+			      break;
+			    default:
+			      std::map< std::string,Graph::NodeMap<double> * > nms=mytab.mapstorage.nodemap_storage;
+			      bool itisvar=(nms.find(ch2var[ polishform[i] ])!=nms.end());
+			      if(itisvar)
+				{
+				  polishstack.push( (*(mytab.mapstorage.nodemap_storage[ ch2var[ polishform[i] ] ]))[k]);
+				}
+			      else
+				{
+				  polishstack.push(atof(ch2var[ polishform[i] ].c_str()));
+				}
+			      operation=false;
+			      break;
+			    }
+			  if(operation)
+			    {
+			      double res;
+			      switch(polishform[i])
+				{
+				case '+':
+				  res=op1+op2;
+				  break;
+				case '-':
+				  res=op2-op1;
+				  break;
+				case '/':
+				  res=op2/op1;
+				  break;
+				case '*':
+				  res=op1*op2;
+				  break;
+				default:
+				  std::cout << "How could we get here?" << std::endl;
+				  break;
+				}
+			      polishstack.push(res);
+			    }
+			}
+		      (*emptr)[k]=polishstack.top(); 
+		    }
+		}
+	      //if addition was not successful addNodeMap returns one.
+	      //cause can be that there is already a map named like the new one
+	      if(mytab.mapstorage.addNodeMap(mapname,emptr, def_val))
+		{
+		  abortion=1;
+		}
+
+	      //add it to the list of the displayable maps
+	      //furthermore it is done by signals
+	      //mytab.registerNewNodeMap(mapname);
+
+	      //display it
+	      //gdc.changeNodeText(mapname);
+	    }
+	  if(!abortion)
+	    {
+	      name.set_text("");
+	      default_value.set_text("0");
+	      edge.show();
+	      node.show();
+	      hide();
+	    }
+	}
+    }
 }
 
@@ -349,113 +307,113 @@
 
   for(int i=0;(valid_entry&&(i<(int)rawcommand.size()));i++)
-  {
-    switch(rawcommand[i])
-    {
-      case '+':
-      case '-':
-      case '*':
-      case '/':
-      case ')':
-      case '(':
-        if(!variable.empty())
-        {
-          valid_entry=validVariable(variable, itisedge);
-          ch2var[index]=variable;
-          command+=index;
-          index++;
-          variable.erase(0,variable.size());	  
-        }
-        command+=rawcommand[i];
-        break;
-      default:
-        variable+=rawcommand[i];
-        break;
-    }
-  }
+    {
+      switch(rawcommand[i])
+	{
+	case '+':
+	case '-':
+	case '*':
+	case '/':
+	case ')':
+	case '(':
+ 	  if(!variable.empty())
+	    {
+	      valid_entry=validVariable(variable, itisedge);
+	      ch2var[index]=variable;
+	      command+=index;
+	      index++;
+	      variable.erase(0,variable.size());	  
+	    }
+	  command+=rawcommand[i];
+	  break;
+	default:
+	  variable+=rawcommand[i];
+	  break;
+	}
+    }
 
   if(!variable.empty()&&valid_entry)
-  {
-    valid_entry=validVariable(variable, itisedge);
-    ch2var[index]=variable;
-    command+=index;
-    index++;
-    variable.erase(0,variable.size());	  
-  }
+    {
+      valid_entry=validVariable(variable, itisedge);
+      ch2var[index]=variable;
+      command+=index;
+      index++;
+      variable.erase(0,variable.size());	  
+    }
 
   if(valid_entry)
-  {
-    unsigned int pr=10000;
-    bool prevmult=false;
-    unsigned int prev_change=pr;
-    unsigned int prev_br=pr;
-    int counter=0;
-    std::string comm_nobr="";
-    std::vector<unsigned int> p;
-    p.resize(counter+1);
-
-    //limits
-    //6 brackets embedded
-    //100 operation in a row from the same priority
-
-    for(int i=0;i<(int)command.size();i++)
-    {
-      bool put_in_string=true;
-      switch(command[i])
-      {
-        case '(':
-          pr=prev_br+10000;
-          prev_br=pr;
-          prevmult=false;
-          put_in_string=false;
-          break;
-        case ')':
-          pr=prev_br-10000;
-          prev_br=pr;
-          prevmult=false;
-          put_in_string=false;
-          break;
-        case '+':
-        case '-':
-          if(prevmult)
-          {
-            pr=prev_change;
-          }
-          p[counter]=pr;
-          pr-=100;
-
-          prevmult=false;
-          break;
-        case '/':
-        case '*':
-          if(!prevmult)
-          {
-            prev_change=pr;
-            pr+=200;
-            pr-=1;
-          }
-          p[counter]=pr;
-          pr-=1;
-          prevmult=true;
-          break;
-        default:
-          p[counter]=65000;
-          break;
-      }
-      if(put_in_string)
-      {
-        counter++;
-        p.resize(counter+1);
-        comm_nobr=comm_nobr+command[i];
-      }
-    }
-
-    tree_node * root=weightedString2Tree(comm_nobr, p, 0);
-
-    std::string polishform=postOrder(root);
-
-    deleteTree(root);
-
-    return polishform;
-  }
+    {
+      unsigned int pr=10000;
+      bool prevmult=false;
+      unsigned int prev_change=pr;
+      unsigned int prev_br=pr;
+      int counter=0;
+      std::string comm_nobr="";
+      std::vector<unsigned int> p;
+      p.resize(counter+1);
+      
+      //limits
+      //6 brackets embedded
+      //100 operation in a row from the same priority
+      
+      for(int i=0;i<(int)command.size();i++)
+	{
+	  bool put_in_string=true;
+	  switch(command[i])
+	    {
+	    case '(':
+	      pr=prev_br+10000;
+	      prev_br=pr;
+	      prevmult=false;
+	      put_in_string=false;
+	      break;
+	    case ')':
+	      pr=prev_br-10000;
+	      prev_br=pr;
+	      prevmult=false;
+	      put_in_string=false;
+	      break;
+	    case '+':
+	    case '-':
+	      if(prevmult)
+		{
+		  pr=prev_change;
+		}
+	      p[counter]=pr;
+	      pr-=100;
+
+	      prevmult=false;
+	      break;
+	    case '/':
+	    case '*':
+	      if(!prevmult)
+		{
+		  prev_change=pr;
+		  pr+=200;
+		  pr-=1;
+		}
+	      p[counter]=pr;
+	      pr-=1;
+	      prevmult=true;
+	      break;
+	    default:
+	      p[counter]=65000;
+	      break;
+	    }
+	  if(put_in_string)
+	    {
+	      counter++;
+	      p.resize(counter+1);
+	      comm_nobr=comm_nobr+command[i];
+	    }
+	}
+
+      tree_node * root=weightedString2Tree(comm_nobr, p, 0);
+
+      std::string polishform=postOrder(root);
+
+      deleteTree(root);
+
+      return polishform;
+    }
   return "";
 }
@@ -464,11 +422,11 @@
 {
   if(node->left_child!=NULL)
-  {
-    deleteTree(node->left_child);
-  }
+    {
+      deleteTree(node->left_child);
+    }
   if(node->right_child!=NULL)
-  {
-    deleteTree(node->right_child);
-  }
+    {
+      deleteTree(node->right_child);
+    }
   delete node;
 }
@@ -479,23 +437,23 @@
   int minplace=0;
   for(int i=0;i<(int)to_tree.size();i++)
-  {
-    if(min>p[offset+i])
-    {
-      min=p[offset+i];
-      minplace=i;
-    }
-  }
+    {
+      if(min>p[offset+i])
+	{
+	  min=p[offset+i];
+	  minplace=i;
+	}
+    }
   tree_node * act_node=new tree_node;
   act_node->ch=to_tree[minplace];
   if(to_tree.size()>=3)
-  {
-    act_node->left_child=weightedString2Tree(to_tree.substr(0,minplace), p, offset);
-    act_node->right_child=weightedString2Tree(to_tree.substr(minplace+1,to_tree.size()-minplace-1), p, offset+minplace+1);
-  }
+    {
+      act_node->left_child=weightedString2Tree(to_tree.substr(0,minplace), p, offset);
+      act_node->right_child=weightedString2Tree(to_tree.substr(minplace+1,to_tree.size()-minplace-1), p, offset+minplace+1);
+    }
   else
-  {
-    act_node->left_child=NULL;
-    act_node->right_child=NULL;
-  }
+    {
+      act_node->left_child=NULL;
+      act_node->right_child=NULL;
+    }
   return act_node;
 }
@@ -505,11 +463,11 @@
   std::string subtree_to_string;
   if(subtree->left_child)
-  {
-    subtree_to_string=postOrder(subtree->left_child);
-  }
+    {
+      subtree_to_string=postOrder(subtree->left_child);
+    }
   if(subtree->right_child)
-  {
-    subtree_to_string=subtree_to_string+postOrder(subtree->right_child);
-  }
+    {
+      subtree_to_string=subtree_to_string+postOrder(subtree->right_child);
+    }
   subtree_to_string=subtree_to_string+subtree->ch;
   return subtree_to_string;
@@ -518,48 +476,42 @@
 bool NewMapWin::validVariable(std::string variable, bool itisedge)
 {
-  MapStorage& ms = *mytab.mapstorage;
-
   bool cancel;
   //is it mapname?
   if(itisedge)
-  {
-    std::vector<std::string> edge_maps =
-      ms.getEdgeMapList(NUM);
-    cancel=(std::find(edge_maps.begin(), edge_maps.end(), variable)==edge_maps.end());
-  }
+    {
+      cancel=(mytab.mapstorage.edgemap_storage.find(variable)==mytab.mapstorage.edgemap_storage.end());
+    }
   else
-  {
-    std::vector<std::string> node_maps =
-      ms.getNodeMapList(NUM);
-    cancel=(std::find(node_maps.begin(), node_maps.end(), variable)==node_maps.end());
-  }
+    {
+      cancel=(mytab.mapstorage.nodemap_storage.find(variable)==mytab.mapstorage.nodemap_storage.end());
+    }
   //maybe it is number
   int point_num=0;
   if(cancel)
-  {
-    cancel=false;
-    for(int j=0;(!cancel)&&(j<(int)variable.size());j++)
-    {
-      if(((variable[j]<'0')||(variable[j]>'9'))&&(variable[j]!='.'))
-      {
-        cancel=true;
-      }
-      else
-      {
-        if(variable[j]=='.')
-        {
-          point_num++;
-          if(point_num>1)
-          {
-            cancel=true;
-          }
-        }
-      }
-    }
-  }
+    {
+      cancel=false;
+      for(int j=0;(!cancel)&&(j<(int)variable.size());j++)
+	{
+	  if(((variable[j]<'0')||(variable[j]>'9'))&&(variable[j]!='.'))
+	    {
+	      cancel=true;
+	    }
+	  else
+	    {
+	      if(variable[j]=='.')
+		{
+		  point_num++;
+		  if(point_num>1)
+		    {
+		      cancel=true;
+		    }
+		}
+	    }
+	}
+    }
   if(cancel)
-  {
-    return false;
-  }
+    {
+      return false;
+    }
   return true;
 }
Index: new_map_win.h
===================================================================
--- new_map_win.h	(revision 201)
+++ new_map_win.h	(revision 174)
@@ -20,10 +20,11 @@
 #define NEWMAPWIN_H
 
+class NewMapWin;
+
 #include <all_include.h>
+#include <nbtab.h>
 #include <libgnomecanvasmm.h>
 #include <libgnomecanvasmm/polygon.h>
 #include <stack>
-
-class NoteBookTab;
 
 ///Graphical interface for node/edge map creation.
@@ -35,13 +36,4 @@
   ///The \ref NoteBookTab in which the new map has to be placed.
   NoteBookTab & mytab;
-
-  MapType map_type;
-  Gtk::Label lblType;
-  Gtk::ComboBoxText cbType;
-
-  Gtk::Label lblErrorMsg;
-  void setErrorMsg(const Glib::ustring& msg);
-
-  std::vector<double>* evaluate_expr(const std::string polishform, bool itisedge);
 
 public:
@@ -69,5 +61,5 @@
   ///It creates the widgets shown in
   ///NewMapWin.
-  NewMapWin(const std::string& title, NoteBookTab &, bool itisedge=true, bool edgenode=true, MapType type = ALL);
+  NewMapWin(const std::string& title, NoteBookTab &, bool itisedge=true, bool edgenode=true);
 
   ///Callback function for OK button. It creates the map.
Index: xml.h
===================================================================
--- xml.h	(revision 201)
+++ xml.h	(revision 174)
@@ -16,7 +16,4 @@
  *
  */
-
-#ifndef GLEMON_XML_H
-#define GLEMON_XML_H
 
 #include <iostream>
@@ -446,3 +443,2 @@
 }
 
-#endif
